/////////////////////////////////////////////////////////////////////
//Verwendung der Bibliothek shiffman.box2d an einem einfachen Beispiel
//Es werden auf mousePressed bunte Rauten mit einer bestimmten Anfangs-
//geschwindigkeit erzeugt. Lernziel: Body und Fixture verstehen
//////////////////////////////////////////////////////////////////////
import shiffman.box2d.*;
import org.jbox2d.collision.shapes.*;
import org.jbox2d.common.*;
import org.jbox2d.dynamics.*;

Box2DProcessing box2d;  
ArrayList<Raute> rauten;  // Liste aller Rauten
color c; //Farbe der Raute

void setup() {
  size(800,600);  
  smooth();
  // Die Physik-Welt in Box2D initalisieren
  box2d = new Box2DProcessing(this);	
  box2d.createWorld();
  box2d.setGravity(0,-10);//Erdbeschleunigung
  // Rauten-Liste intialisieren
  rauten = new ArrayList<Raute>();
 
}

void draw() {
  background(0);  
  // Zeitschritt
  box2d.step();    
  // Erzeugen neuer neuen Raute bei Maus-Klick 
  if(mousePressed){ 
      c= color(random(255),random(255),random(255));
      Raute rT = new Raute(mouseX,mouseY,c);
      rauten.add(rT); 
  }
  // Alle Rautee anzeigen
  for (Raute rT: rauten) {
    rT.display();
  }
 
  for (int i = rauten.size()-1; i >= 0; i--) {
    Raute rT = rauten.get(i);
    if (rT.verschwunden()) {
      rauten.remove(i);
    }
  }
  
}